HDU 4240

http://acm.hdu.edu.cn/showproblem.php?pid=4240

题意:求最大流和流量最大的一条路径的流量的比值

题解:流量最大的路径的流量在dinic的dfs每次搜到终点的时候更新最大值

#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <iostream>
#include <algorithm>
using namespace std; 

const int INF=0xfffffff ;
struct node
{
    int s,t,cap,nxt ;
}e[400005] ;
int m,n,cnt,head[100005],level[100005],q[100005],maxn ;
void add(int s,int t,int cap)
{
    e[cnt].s=s ;e[cnt].t=t ;e[cnt].cap=cap ;e[cnt].nxt=head[s] ;head[s]=cnt++ ;
    e[cnt].s=t ;e[cnt].t=s ;e[cnt].cap=0 ;e[cnt].nxt=head[t] ;head[t]=cnt++ ;
}
bool build(int s,int t)
{
    int front=0,rear=0 ;
    memset(level,-1,sizeof(level)) ;
    q[rear++]=s ;
    level[s]=1 ;
    while(front<rear)
    {
        int u=q[front++] ;
        for(int i=head[u] ;i!=-1 ;i=e[i].nxt)
        {
            int tt=e[i].t ;
            if(level[tt]==-1 && e[i].cap>0)
            {
                level[tt]=level[u]+1 ;
                if(tt==t)return true ;
                q[rear++]=tt ;
            }
        }
    }
    return false ;
}
int find(int s,int t,int flow)
{
    if(s==t)
    {
        maxn=max(maxn,flow) ;
        return flow ;
    }
    int ret=0,a ;
    for(int i=head[s] ;i!=-1 ;i=e[i].nxt)
    {
        int tt=e[i].t ;
        if(level[tt]==level[s]+1 && e[i].cap>0)
        {
            a=find(tt,t,min(e[i].cap,flow-ret)) ;
            e[i].cap-=a ;
            e[i^1].cap+=a ;
            ret+=a ;
            if(ret==flow)
                return ret ;
        }
    }
    if(!ret)level[s]=-1 ;
    return ret ;
}
int dinic(int s,int t)
{
    int flow,ret=0 ;
    while(build(s,t))
        while(flow=find(s,t,INF))
            ret+=flow ;
    return ret ;
}
int main()
{

    int N,S,T,cas ;
    scanf("%d",&cas) ;
    while(cas--)
    {
        scanf("%d%d%d%d%d",&N,&n,&m,&S,&T) ;
        memset(head,-1,sizeof(head)) ;
        cnt=0 ;
        maxn=0 ;
        while(m--)
        {
            int s,t,v ;
            scanf("%d%d%d",&s,&t,&v) ;
            add(s,t,v) ;
        }
        printf("%d %.3f\n",N,dinic(S,T)*1.0/maxn) ;
    }
    return 0 ;
}

HDU 4240

时间: 2024-10-08 19:35:15

HDU 4240的相关文章

HDU 4240 Route Redundancy 一条流最大的路径

题目来源:HDU 4240 Route Redundancy 题意:求最大流与一条流最大的路径的比值 前者最大流求出 后者是每一条路的最小值再取大 思路:我用的是dinic 可以在DFS的时候在传递一个参数 表示当前增广路可以通过最大的流量 然后当x==t 到达汇点时 在取他们的最大值 #include <cstdio> #include <queue> #include <vector> #include <cstring> #include <al

hdu 4240 Route Redundancy 最大流

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=4240 A city is made up exclusively of one-way steets.each street in the city has a capacity,which is the minimum of the capcities of the streets along that route. The redundancy ratio from point A to poi

HDU 4240 Route Redundancy

Route Redundancy Time Limit: 1000ms Memory Limit: 32768KB This problem will be judged on HDU. Original ID: 424064-bit integer IO format: %I64d      Java class name: Main A city is made up exclusively of one-way steets.each street in the city has a ca

hdu 4240(最大流+最大流量的路)

Route Redundancy Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 625    Accepted Submission(s): 367 Problem Description A city is made up exclusively of one-way steets.each street in the city ha

hdu 4240 最大流量路径

题意弄了半天: 给出一个有向图,带边权,src,dst. 求出src到dst的最大流,再求出从src到dst流量最大的路径的流量,求它们的比值. 1 #include <cstdio> 2 #include <cstring> 3 #include <queue> 4 #include <vector> 5 #define oo 0x3f3f3f3f 6 #define maxn 1010 7 using namespace std; 8 9 struct

HDU 6203 ping ping ping [LCA,贪心,DFS序,BIT(树状数组)]

题目链接:[http://acm.hdu.edu.cn/showproblem.php?pid=6203] 题意 :给出一棵树,如果(a,b)路径上有坏点,那么(a,b)之间不联通,给出一些不联通的点对,然后判断最少有多少个坏点. 题解 :求每个点对的LCA,然后根据LCA的深度排序.从LCA最深的点对开始,如果a或者b点已经有点被标记了,那么continue,否者标记(a,b)LCA的子树每个顶点加1. #include<Bits/stdc++.h> using namespace std;

HDU 5542 The Battle of Chibi dp+树状数组

题目:http://acm.hdu.edu.cn/showproblem.php?pid=5542 题意:给你n个数,求其中上升子序列长度为m的个数 可以考虑用dp[i][j]表示以a[i]结尾的长度为j的上升子序列有多少 裸的dp是o(n2m) 所以需要优化 我们可以发现dp的第3维是找比它小的数,那么就可以用树状数组来找 这样就可以降低复杂度 #include<iostream> #include<cstdio> #include<cstring> #include

hdu 1207 汉诺塔II (DP+递推)

汉诺塔II Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 4529    Accepted Submission(s): 2231 Problem Description 经典的汉诺塔问题经常作为一个递归的经典例题存在.可能有人并不知道汉诺塔问题的典故.汉诺塔来源于印度传说的一个故事,上帝创造世界时作了三根金刚石柱子,在一根柱子上从下往

[hdu 2102]bfs+注意INF

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2102 感觉这个题非常水,结果一直WA,最后发现居然是0x3f3f3f3f不够大导致的--把INF改成INF+INF就过了. #include<bits/stdc++.h> using namespace std; bool vis[2][15][15]; char s[2][15][15]; const int INF=0x3f3f3f3f; const int fx[]={0,0,1,-1};